var optimizelySDK = require('@optimizely/optimizely-sdk');

var DEFAULT_OPTIONS = {
  autoUpdate: true,
  updateInterval: 10 * 1000 // 10 seconds in milliseconds

};
var DEFAULT_TIMEOUT = 500;

var OptimizelyAdapter = /*#__PURE__*/function () {
  function OptimizelyAdapter(_ref) {
    var optimizely = _ref.optimizely,
        userId = _ref.userId;

    if (this._userId) {
      throw new Error('userId is mandatory to use OptimizelyAdapter');
    }

    if (this._optimizely) {
      throw new Error('optimizely instance is mandatory to use OptimizelyAdapter');
    }

    this._optimizely = optimizely;
    this._userId = userId;
  }

  OptimizelyAdapter.createOptimizelyInstance = function createOptimizelyInstance(_ref2) {
    var _ref2$options = _ref2.options,
        options = _ref2$options === void 0 ? DEFAULT_OPTIONS : _ref2$options,
        sdkKey = _ref2.sdkKey;
    optimizelySDK.setLogLevel('info');
    optimizelySDK.setLogger(optimizelySDK.logging.createLogger());
    return optimizelySDK.createInstance({
      sdkKey: sdkKey,
      datafileOptions: options
    });
  };

  var _proto = OptimizelyAdapter.prototype;

  _proto.getEnabledFeatures = function getEnabledFeatures(_temp) {
    var _this = this;

    var _ref3 = _temp === void 0 ? {} : _temp,
        attributes = _ref3.attributes;

    return this._onReady().then(function (optimizely) {
      return optimizely.getEnabledFeatures(_this._userId.toString(), attributes);
    });
  };

  _proto._onReady = function _onReady() {
    var _this2 = this;

    return this._optimizely.onReady({
      timeout: DEFAULT_TIMEOUT
    }).then(function () {
      return _this2._optimizely;
    });
  };

  return OptimizelyAdapter;
}();

export { OptimizelyAdapter as default };